package multi;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Enumeration;
import java.util.List;

import com.ibm.aglet.Aglet;
import com.ibm.aglet.AgletContext;
import com.ibm.aglet.AgletProxy;
import com.ibm.aglet.InvalidAgletException;
import com.ibm.aglet.Message;

public class AgenteA extends Aglet
{
    AgletProxy bJ, bM;

    @Override
    public void onCreation(Object init)
    {
        AgletContext context = getAgletContext();

        context.setProperty("Agente A", getProxy());

        try
        {
            bJ = context.createAglet(null, "multi.AgenteB", "Joo");

            bM = context.createAglet(null, "multi.AgenteB", "Maria");
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    @Override
    public boolean handleMessage(Message message)
    {
        if (message.getKind().equals("M1"))
        {
            System.out.println("Chegou a mensagem do Agente B " + message.getArg());

            Enumeration e = getAgletContext().getAgletProxies();
            
            List proxies = Collections.list(e);
            
            for (int i = 0; i<proxies.size(); i++)
            {
            	AgletProxy p = (AgletProxy)proxies.get(i);
            	
            	System.out.println(p.toString());
            }
            
            return true;
        }

        return false;
    }

    @Override
    public void onDisposing()
    {

        try
        {
            if (bJ != null)
                bJ.dispose();
            
            if (bM != null)
                bM.dispose();
        }
        catch (InvalidAgletException e)
        {
            e.printStackTrace();
        }
    }
}
